Attribute VB_Name = "TextualSum4Xls"
Option Explicit
' A Microsoft ltal kzztett Excel VBA funkci alapjn ksztette Horvth Ferenc, FranXervE - 2005.

Sub Hungarian()
Dim MyNumber, myHuBig, myHuSmall
Dim myResponse As Byte

Dim Message, Title, Default
Message = "rd be a vgsszeget!" & vbCrLf & "A tizedest vesszvel!"    ' Felszlts.
Title = "Szmlasszeg -> Magyar szveg talakt"    ' Cm.
Default = "1"    ' Alaprtk.
' zenet, cm s alaprtk megjelentse.
    MyNumber = InputBox(Message, Title, Default)
    If MyNumber = "" Then Exit Sub
' Vlaszts az US dollr s az Eur kztt.
        myResponse = MsgBox("Yes -- US dollr," _
        & vbCrLf & "No -- Eur" & vbCrLf _
        & "Cancel -- Kilps", vbQuestion + vbYesNoCancel _
        + vbDefaultButton1 + vbApplicationModal, "Szmlasszeg -> Magyar szveg talakt")

    Select Case myResponse
        Case vbYes '(Alaprtelmezett)
          myHuBig = "US dollr"
          myHuSmall = "cent"
        Case vbNo
          myHuBig = "Eur"
          myHuSmall = "cent"
        Case vbCancel
          Exit Sub
    End Select
Call ValutaMagyarra(MyNumber, myHuBig, myHuSmall)

End Sub
Sub English()
Dim MyNumber, myEnBig, myEnSmall
Dim myResponse As Byte

Dim Message, Title, Default
Message = "rd be a vgsszeget!" & vbCrLf & "A tizedest vesszvel!"    ' Felszlts.
Title = "Szmlasszeg -> Angol szveg talakt"    ' Cm.
Default = "1"    ' Alaprtk.
' zenet, cm s alaprtk megjelentse.
    MyNumber = InputBox(Message, Title, Default)
    If MyNumber = "" Then Exit Sub
' Vlaszts az US dollar s az Euro kztt.
        myResponse = MsgBox("Yes -- US dollar," _
        & vbCrLf & "No -- Euro" & vbCrLf _
        & "Cancel -- Kilps", vbQuestion + vbYesNoCancel _
        + vbDefaultButton1 + vbApplicationModal, "Szmlasszeg -> Angol szveg talakt")

    Select Case myResponse
        Case vbYes '(Alaprtelmezett)
          myEnBig = "US dollar"
          myEnSmall = "Cent"
        Case vbNo
          myEnBig = "Euro"
          myEnSmall = "Cent"
        Case vbCancel
          Exit Sub
    End Select
Call CurrencyToEnglish(MyNumber, myEnBig, myEnSmall)

End Sub
Private Function ValutaMagyarra(ByVal MyNumber, myHuBig, myHuSmall)
   Dim Temp
   Dim Nagy, Kicsi
   Dim TizedesHely, Count

   ReDim Hely(9)

   Hely(2) = "ezer "
   Hely(3) = "milli "
   Hely(4) = "billi "
   Hely(5) = "trilli "

   'Karaktersorozatt alaktja a szmot s levgja a felesleges helyet.
   MyNumber = Trim(CStr(MyNumber))

   'Megkeresi a tizedeshelyet.
   TizedesHely = InStr(MyNumber, ",")

   'Ha a tizedes megvan...
   If TizedesHely > 0 Then
      'talaktja az aprt
      Temp = Left(Mid(MyNumber, TizedesHely + 1) & "00", 2)
      Kicsi = ConvertHuTens(Temp)
      'Leveszi az aprt az talaktshoz.
      MyNumber = Trim(Left(MyNumber, TizedesHely - 1))
   End If

   Count = 1

   Do While MyNumber <> ""
      'talaktja az sszeg utols 3 szmjegyt az adott valutra.
      Temp = ConvertHuHundreds(Right(MyNumber, 3))
      If Temp <> "" Then Nagy = Temp & Hely(Count) & Nagy
      If Len(MyNumber) > 3 Then
         'Eltvoltja az sszegrl az utols 3 talaktott szmot.
         MyNumber = Left(MyNumber, Len(MyNumber) - 3)
      Else
         MyNumber = ""
      End If
      Count = Count + 1
   Loop

   'Rendbe teszi az egsz rtket.
   Select Case Nagy
      Case ""
         Nagy = "Nulla " & myHuBig
      Case Else
         Nagy = Nagy & " " & myHuBig
   End Select

   'Rendbe teszi az aprt.
   Select Case Kicsi
      Case ""
         Kicsi = " s nulla " & myHuSmall
      Case Else
         Kicsi = " s " & Kicsi & " " & myHuSmall
   End Select

    ' Berja a szveges sszeget az aktv cellba
'    ActiveCell.Value = "(azaz " & Nagy & Kicsi & ")"
    ActiveCell.Value = Nagy & Kicsi
End Function

Private Function ConvertHuHundreds(ByVal MyNumber)
   Dim Result

   'Kilp, ha nincs mit atalaktani.
   If CInt(MyNumber) = 0 Then Exit Function

   'Felrakja a szmhoz a bevezet nullkat.
   MyNumber = Right("000" & MyNumber, 3)

   'Van szzas helyirtk, talaktand szm?
   If Left(MyNumber, 1) <> "0" Then
      Result = ConvertHuDigit(Left(MyNumber, 1)) & "szz"
   End If

   'Van tizes helyirtk, talaktand szm?
   If Mid(MyNumber, 2, 1) <> "0" Then
      Result = Result & ConvertHuTens(Mid(MyNumber, 2))
   Else
      'Ha nincs, talaktja az egyes helyirtkeket.
      Result = Result & ConvertHuDigit(Mid(MyNumber, 3))
   End If

   ConvertHuHundreds = Trim(Result)
End Function

Private Function ConvertHuTens(ByVal MyHuTens)
   Dim Result

   'Van 10 s 19 kztti rtk?
   If CInt(Left(MyHuTens, 1)) = 1 Then
      Select Case CInt(MyHuTens)
         Case 10: Result = "tz"
         Case 11: Result = "tizenegy"
         Case 12: Result = "tizenkett"
         Case 13: Result = "tizenhrom"
         Case 14: Result = "tizenngy"
         Case 15: Result = "tizent"
         Case 16: Result = "tizenhat"
         Case 17: Result = "tizenht"
         Case 18: Result = "tizennyolc"
         Case 19: Result = "tizenkilenc"
         Case Else
      End Select
   'Van 20 s 29 kztti rtk?
    ElseIf CInt(Left(MyHuTens, 1)) = 2 Then
      Select Case CInt(MyHuTens)
         Case 20: Result = "hsz"
         Case 21: Result = "huszonegy"
         Case 22: Result = "huszonkett"
         Case 23: Result = "huszonhrom"
         Case 24: Result = "huszonngy"
         Case 25: Result = "huszont"
         Case 26: Result = "huszonhat"
         Case 27: Result = "huszonht"
         Case 28: Result = "huszonnyolc"
         Case 29: Result = "huszonkilenc"
         Case Else
      End Select
   Else
      '... klnben 30 s 99 kz esik.
      Select Case CInt(Left(MyHuTens, 1))
         Case 3: Result = "harminc"
         Case 4: Result = "negyven"
         Case 5: Result = "tven"
         Case 6: Result = "hatvan"
         Case 7: Result = "hetven"
         Case 8: Result = "nyolcvan"
         Case 9: Result = "kilencven"
         Case Else
      End Select
      'talaktja az egyes helyirtk szmot.
      Result = Result & ConvertHuDigit(Right(MyHuTens, 1))
   End If

   ConvertHuTens = Result
End Function

Private Function ConvertHuDigit(ByVal MyHuDigit)
   Select Case CInt(MyHuDigit)
      Case 1: ConvertHuDigit = "egy"
      Case 2: ConvertHuDigit = "kett"
      Case 3: ConvertHuDigit = "hrom"
      Case 4: ConvertHuDigit = "ngy"
      Case 5: ConvertHuDigit = "t"
      Case 6: ConvertHuDigit = "hat"
      Case 7: ConvertHuDigit = "ht"
      Case 8: ConvertHuDigit = "nyolc"
      Case 9: ConvertHuDigit = "kilenc"
      Case Else: ConvertHuDigit = ""
   End Select
End Function
Private Function CurrencyToEnglish(ByVal MyNumber, myEnBig, myEnSmall)
   Dim Temp
   Dim Big, Small
   Dim DecimalPlace, Count

   ReDim Place(9)

   Place(2) = " Thousand "
   Place(3) = " Million "
   Place(4) = " Billion "
   Place(5) = " Trillion "

   'Karaktersorozatt alaktja a szmot s levgja a felesleges helyet.
   MyNumber = Trim(CStr(MyNumber))

   'Megkeresi a tizedeshelyet.
   DecimalPlace = InStr(MyNumber, ",")

   'Ha a tizedes megvan...
   If DecimalPlace > 0 Then
      'talaktja az aprt
      Temp = Left(Mid(MyNumber, DecimalPlace + 1) & "00", 2)
      Small = ConvertTens(Temp)
      'Leveszi az aprt az talaktshoz.
      MyNumber = Trim(Left(MyNumber, DecimalPlace - 1))
   End If

   Count = 1

   Do While MyNumber <> ""
      'talaktja az sszeg utols 3 szmjegyt az adott valutra.
      Temp = ConvertHundreds(Right(MyNumber, 3))
      If Temp <> "" Then Big = Temp & Place(Count) & Big
      If Len(MyNumber) > 3 Then
         'Eltvoltja az sszegrl az utols 3 talaktott szmot.
         MyNumber = Left(MyNumber, Len(MyNumber) - 3)
      Else
         MyNumber = ""
      End If
      Count = Count + 1
   Loop

   'Rendbe teszi az egsz rtket.
   Select Case Big
      Case ""
         Big = "No " & myEnBig & "s"
      Case "One"
         Big = "One " & myEnBig
      Case Else
         Big = Big & " " & myEnBig & "s"
   End Select

   'Rendbe teszi az aprt.
   Select Case Small
      Case ""
         Small = " And No Cents"
      Case "One"
         Small = " And One Cent"
      Case Else
         Small = " And " & Small & " Cents"
   End Select

    ' Berja a szveges sszeget az aktv cellba.
'    ActiveCell.Value = "(that is " & Big & Small & ")"
    ActiveCell.Value = Big & Small
End Function

Private Function ConvertHundreds(ByVal MyNumber)
   Dim Result

   'Kilp, ha nincs mit atalaktani.
   If CInt(MyNumber) = 0 Then Exit Function

   'Felrakja a szmhoz a bevezet nullkat.
   MyNumber = Right("000" & MyNumber, 3)

   'Van szzas helyirtk, talaktand szm?
   If Left(MyNumber, 1) <> "0" Then
      Result = ConvertDigit(Left(MyNumber, 1)) & " Hundred "
   End If

   'Van tizes helyirtk, talaktand szm?
   If Mid(MyNumber, 2, 1) <> "0" Then
      Result = Result & ConvertTens(Mid(MyNumber, 2))
   Else
      'Ha nincs, talaktja az egyes helyirtkeket.
      Result = Result & ConvertDigit(Mid(MyNumber, 3))
   End If

   ConvertHundreds = Trim(Result)
End Function

Private Function ConvertTens(ByVal MyTens)
   Dim Result

   'Van 10 s 19 kztti rtk?
   If CInt(Left(MyTens, 1)) = 1 Then
      Select Case CInt(MyTens)
         Case 10: Result = "Ten"
         Case 11: Result = "Eleven"
         Case 12: Result = "Twelve"
         Case 13: Result = "Thirteen"
         Case 14: Result = "Fourteen"
         Case 15: Result = "Fifteen"
         Case 16: Result = "Sixteen"
         Case 17: Result = "Seventeen"
         Case 18: Result = "Eighteen"
         Case 19: Result = "Nineteen"
         Case Else
      End Select
   Else
      '... klnben 20 s 99 kz esik.
      Select Case CInt(Left(MyTens, 1))
         Case 2: Result = "Twenty "
         Case 3: Result = "Thirty "
         Case 4: Result = "Forty "
         Case 5: Result = "Fifty "
         Case 6: Result = "Sixty "
         Case 7: Result = "Seventy "
         Case 8: Result = "Eighty "
         Case 9: Result = "Ninety "
         Case Else
      End Select
      'talaktja az egyes helyirtk szmot.
      Result = Result & ConvertDigit(Right(MyTens, 1))
   End If

   ConvertTens = Result
End Function

Private Function ConvertDigit(ByVal MyDigit)
   Select Case CInt(MyDigit)
      Case 1: ConvertDigit = "One"
      Case 2: ConvertDigit = "Two"
      Case 3: ConvertDigit = "Three"
      Case 4: ConvertDigit = "Four"
      Case 5: ConvertDigit = "Five"
      Case 6: ConvertDigit = "Six"
      Case 7: ConvertDigit = "Seven"
      Case 8: ConvertDigit = "Eight"
      Case 9: ConvertDigit = "Nine"
      Case Else: ConvertDigit = ""
   End Select
End Function

